//Dialog.hpp

#ifndef _DIALOG_H_
#define _DIALOG_H_

#define IS_FLAG( val,flag ) (((val)&(flag))==(flag))
typedef const char *CONSTSTR;

#define FFDI_FOCUSED   0x00010000UL
#define FFDI_SELECTED  0x00020000UL
#define FFDI_DEFAULT   0x00040000UL

typedef struct FDialogItem
{
  DWORD    Type;
  int      X1;
  int      Y1;
  int      X2;
  int      Y2;
  DWORD    Flags;
  CONSTSTR Text;
} *PFDialogItem;

typedef struct FarDialogItem *PFarDialogItem;

//   
#define FDI_CONTROL( tp,x,y,x1,y1,fl,txt )    { tp,x,y,x1,y1,fl,txt }
//    
#define FDI_DOUBLEBOX( h,w,txt )              FDI_CONTROL( DI_DOUBLEBOX,3,1,(h-4),(w-2),0,txt )
//  ( )
#define FDI_LABEL( x,y,txt )                  FDI_CONTROL( DI_TEXT,x,y,0,0,0,txt )
//  
#define FDI_SEPARATOR(y)                      FDI_CONTROL( DI_TEXT,-1,y,0,0,DIF_SEPARATOR,NULL )
//  
#define FDI_COLORLABEL( x,y,clr,txt )         FDI_CONTROL( DI_TEXT,x,y,0,0,DIF_SETCOLOR|(clr),txt )
//  
#define FDI_EDIT( x,y,x1 )                    FDI_CONTROL( DI_EDIT,x,y,x1,y,0,NULL )
//    ReadOnly 
#define FDI_DISABLEDEDIT( x,y,x1 )            FDI_CONTROL( DI_EDIT,x,y,x1,y,DIF_DISABLE,NULL )
// 
#define FDI_CHECK( x,y,txt )                  FDI_CONTROL( DI_CHECKBOX,x,y,0,0,0,txt )
//  
#define FDI_RADIO( x,y,txt )                  FDI_CONTROL( DI_RADIOBUTTON,x,y,0,0,0,txt )
//   
#define FDI_STARTRADIO( x,y,txt )             FDI_CONTROL( DI_RADIOBUTTON,x,y,0,0,DIF_GROUP,txt )
// 
#define FDI_BUTTON( x,y,txt )                 FDI_CONTROL( DI_BUTTON,x,y,0,0,0,txt )
//   
#define FDI_DEFBUTTON( x,y,txt )              FDI_CONTROL( DI_BUTTON|FFDI_DEFAULT,x,y,0,0,0,txt )

template <class T> class RefArray
{
  T *items;
  int count;
 public:
  RefArray( int Count )    { count = Count; items = new T[count]; }
  virtual ~RefArray()      { delete items; }
  T *Item( int num )       const { return (T *)( (num >= 0 && num < count) ? (items + num) : NULL ); }
  T *operator[]( int num ) const { return Item(num); }
  int Count( void )        const { return count; }
  T *Items( void )         const { return (T *)items; }
};

typedef class CConfigDialog *PConfigDialog;

class CConfigDialog: public RefArray<FarDialogItem>
{
 public:
  //CConfigDialog( int NumElemens );
  CConfigDialog( int NumElemens, PFDialogItem Elements, int FNumElements = -1 );
  PFarDialogItem Setup( int num, const FDialogItem &p );
  void Setup( int From,PFDialogItem p,int count );
  int Execute( int w,int h,CONSTSTR Help = NULL );
};

#endif