//pclasses.cpp

char s_MethodType[] = "%MethodType%";
char s_MethodName[] = "%MethodName%";
char s_ClassName[] = "%ClassName%";
char s_RegWord[] = "(\\w+)";
char s_Definition[] = "Definition";
char s_End[] = "End";
char s_Implementation[] = "Implementation";
char s_Method[] = "Method";
char s_GlobalProc[] = "GlobalProc";
char s_Type[] = "Type";
char s_Pos[] = "Pos";
char s_MethodTypePos[] = "MethodTypePos";
char s_MethodNamePos[] = "MethodNamePos";

const static char path_root[] = "\\";
char s_FileExts[] = "FileExts";
char s_ExcludedFileExts[] = "ExcludedFileExts";
char s_Include[] = "Include";
char s_Language[] = "Language";
char s_File[] = "File";
char s_Name[] = "name";
char s_SpecVars[] = "SpecVars";
char s_Var[] = "Var";
char s_Value[] = "Value";
char s_Class[] = "Class";
char s_SearchPaths[] = "SearchPaths";
char s_SourceFiles[] = "SourceFiles"; 
char s_Headers[] = "Headers"; 
char s_version[] = "version";
char s_versionID[] = "0.1";
char s_TextNavigate[] = "TextNavigate";

bool IsHeader; bool GlobalProc;
char *HeaderOrSourceFileName; //[ MAX_PATH ];
char ClassDefinition[100];
char MethodImplementation[200];
int MethodNamePos;

CTextNavigate::CTextNavigate()
{
  //memset(this, 0, sizeof(CTextNavigate));
  //   CharSet
  InitUnion();

  XMLFilesColl = new CXMLFilesColl();
  FPrevKeyCode = 0;
  //memset(HeaderOrSourceFileName, 0, MAX_PATH );
}

CTextNavigate::~CTextNavigate()
{
  delete XMLFilesColl;
}

int CTextNavigate::ProcessEditorInput(const INPUT_RECORD *Rec)
{
  if( Rec->EventType == KEY_EVENT && Rec->Event.KeyEvent.bKeyDown &&
      ((Rec->Event.KeyEvent.dwControlKeyState&LEFT_CTRL_PRESSED) ||
       (Rec->Event.KeyEvent.dwControlKeyState&RIGHT_CTRL_PRESSED)) )
  {
    FKeyCode = Rec->Event.KeyEvent.wVirtualKeyCode;
    if( ((FKeyCode == VK_UP)||(FKeyCode == VK_DOWN) ) &&
        (Rec->Event.KeyEvent.dwControlKeyState&LEFT_ALT_PRESSED ||
         Rec->Event.KeyEvent.dwControlKeyState&RIGHT_ALT_PRESSED) )
    { // Ctrl-Alt-Up/Down
      int res = processCtrlAltUpDown(FKeyCode, FPrevKeyCode);
      FPrevKeyCode = FKeyCode;
      return( res );
    }//if( Ctrl-Alt-Up/Down )
    else if( FKeyCode == VK_RETURN )
    {
   #ifdef _DEBUG
    FarSprintf(tmp_str, "Ctrl-Enter Pressed");
    WRITE_TO_LOG_FILE(tmp_str);
   #endif
      return( processCtrlEnter() );
    }
    else if( ((FKeyCode == VK_UP) || (FKeyCode==VK_DOWN)) &&
            (Rec->Event.KeyEvent.dwControlKeyState&SHIFT_PRESSED) )
    {
      int res = processCtrlShiftUpDown(FKeyCode);
      return( res );
    }
    FPrevKeyCode = 0;
  }
  return( FALSE );
}//ProcessEditorInput

int CTextNavigate::ProcessEditorEvent(int Event, void *Param)
{
 int ret = 0;
 switch ( Event )
 {
   case EE_READ:
     struct EditorInfo EInfo;
     if( Info.EditorControl(ECTL_GETINFO, &EInfo) )
     {
       XMLFile = new CXMLFile();
       if( !XMLFile ) break;
       XMLFilesColl->Add(EInfo.EditorID, XMLFile);

       if( HeaderOrSourceFileName && !FSF.LStricmp(EInfo.FileName, HeaderOrSourceFileName) )
       {
         int x_pos, res;
         int CurLine = IsHeader ? EInfo.TotalLines : 0;

         if( IsHeader )
           res = SearchForMethodDefinition(CurLine, x_pos, GlobalProc);
         else
          res = SearchForMethodImplementation2(CurLine, x_pos);

         if( res )
           set_cursor_pos(x_pos, CurLine, &EInfo);

         if( EInfo.TotalLines == 1 && IsHeader )
         {
           //MakeHeader();
         }
         delete HeaderOrSourceFileName;
         //memset(HeaderOrSourceFileName, 0, MAX_PATH );
       }
     }
     break;

   case EE_CLOSE:
     XMLFile = XMLFilesColl->Get(*(int *)Param);
     if( !XMLFile ) break;
     XMLFilesColl->Delete(*(int *)Param);
     break;
 }
 return ret;
}//ProcessEditorEvent

int CTextNavigate::processCtrlAltUpDown(int FKeyCode, int FPrevKeyCode)
{
 #ifdef _DEBUG
  if( FKeyCode == VK_UP )
    WRITE_TO_LOG_FILE("Ctrl-Alt-Up pressed");
  else
    WRITE_TO_LOG_FILE("Ctrl-Alt-Down pressed");
 #endif
  struct EditorInfo EInfo;
  if( !Info.EditorControl(ECTL_GETINFO, &EInfo) )
    return( FALSE );

  XMLFile = XMLFilesColl->Get(EInfo.EditorID);
  if( !XMLFile )
    return( FALSE );

  InitUnion();
  //int BeginLine = (EInfo.BlockType == BTYPE_STREAM)?EInfo.BlockStartLine:EInfo.CurLine;
  int BeginLine = EInfo.CurLine, CurLine = BeginLine;

  int mx, my;
  if( !get_cursor_pos(mx, my) )
    return( FALSE );

  struct EditorGetString EStr;
  EStr.StringNumber = CurLine;
  if( !Info.EditorControl(ECTL_GETSTRING, &EStr) )
    return( FALSE );

  char *String = (char *)EStr.StringText;

  int SearchSelection = searchselection && (EInfo.BlockType == BTYPE_STREAM);
  //     ,  
  if( !SearchSelection && (mx <= EStr.StringLength) )
  {
    //if( mx && ((String[mx] == ' ') || (mx == EStr.StringLength)) && is_char(String[mx-1] ) )
    if( mx && 
        (!is_char(String[mx]) || (mx == EStr.StringLength)) && 
        is_char(String[mx-1]))
     mx--;
  }
  int begin_word_pos = mx;

  if( !FPrevKeyCode ) //    Ctrl-Alt-Up/Down
  {
    //  
    if( SearchSelection )
    {
      memset( &CharSet, 0xFF, 32 ); //  
      struct EditorGetString egs;
      egs.StringNumber = EInfo.BlockStartLine;
      if( !Info.EditorControl(ECTL_GETSTRING, &egs) )
       return( FALSE );
      String = (char *)egs.StringText;
      int SelLength = egs.SelEnd == -1 ? egs.StringLength : egs.SelEnd - egs.SelStart;
      strncpy(word, &String[egs.SelStart], SelLength);
      word[SelLength] = 0;
    }
    else //      word
      if( begin_word_pos > EStr.StringLength || !get_word(word, String, begin_word_pos, EStr.StringLength, begin_word_pos) )
        *word = 0;
  }

  if( !*word )
   return( FALSE );
  if( !casesensitive )
    FSF.LStrlwr(word);

  UCHAR strlen_word = (UCHAR)strlen(word);
  int search_pos = FKeyCode==VK_UP ? begin_word_pos : begin_word_pos+1;
  int borders_crossed = FALSE; //- <- R

  EStr.StringNumber = -1; //  
  struct EditorSetPosition esp;
  esp.CurPos = esp.CurTabPos = esp.TopScreenLine = esp.LeftPos = esp.Overtype = -1;

  if( !FPrevKeyCode || FKeyCode != FPrevKeyCode) //    Ctrl-Alt-Up/Down
    InitQuickSearch(FKeyCode, word, strlen_word);

  int pos_found;
  for( ; ; esp.CurLine = CurLine )
  {
    if( CurLine != BeginLine || borders_crossed )
    {
      Info.EditorControl(ECTL_SETPOSITION,&esp);
      Info.EditorControl(ECTL_GETSTRING,&EStr);
      String = (char *)EStr.StringText;
      search_pos = FKeyCode == VK_UP?EStr.StringLength : 0;
    }

    if( (pos_found = FKeyCode==VK_UP?QuickSearch_BW(String, word, search_pos, strlen_word, SearchSelection, casesensitive):
                               QuickSearch_FW(String, word, EStr.StringLength, strlen_word, search_pos, SearchSelection, casesensitive)) != -1 )
      break;

    FKeyCode == VK_UP ? CurLine-- : CurLine++;

    if( (CurLine == -1) && (FKeyCode == VK_UP) ) //      
      if( cyclicsearch )
      {
        CurLine = EInfo.TotalLines - 1;
        borders_crossed = TRUE;
      }else break;
    else if( (CurLine == EInfo.TotalLines) && (FKeyCode==VK_DOWN) ) //   
      if( cyclicsearch )
      {
        CurLine = 0;
        borders_crossed = TRUE;
      }else break;
    if( CheckForEsc() )
     break;
  }

  set_cursor_pos(pos_found, CurLine, &EInfo);
  //Colorize(strlen_word);
  return( pos_found != -1? TRUE: FALSE );
}//processCtrlAltUpDown

/*
void CTextNavigate::Colorize(int strlen_word)
{
    struct EditorInfo ei;
    Info.EditorControl( ECTL_GETINFO, &ei );

    struct EditorColor ec;
    ec.StringNumber = -1;
    ec.StartPos = ei.CurPos;
    ec.EndPos = ei.CurPos + strlen_word - 1;
    ec.Color = 0x2F; // : 0;

    Info.EditorControl( ECTL_ADDCOLOR, &ec );
    Info.EditorControl(ECTL_REDRAW,NULL);
};
*/
int CTextNavigate::processCtrlEnter(void)
{
  struct EditorInfo EInfo;
  if( !Info.EditorControl(ECTL_GETINFO, &EInfo) )
   return( FALSE );

  XMLFile = XMLFilesColl->Get(EInfo.EditorID);
  if( !XMLFile || !XMLFile->SearchPaths )
    return( FALSE );
  //PSearchPaths SearchPaths = XMLFile->SearchPaths;
  return( XMLFile->SearchPaths->ProcessCtrlEnter(XMLFile->Language) );
}//processCtrlEnter

int CTextNavigate::processCtrlShiftUpDown(int FKeyCode)
{
 #ifdef _DEBUG
  if( FKeyCode == VK_UP )
    WRITE_TO_LOG_FILE("Ctrl-Shift-Up pressed");
  else
    WRITE_TO_LOG_FILE("Ctrl-Shift-Down pressed");
 #endif
  struct EditorInfo EInfo;
  if( !Info.EditorControl(ECTL_GETINFO, &EInfo) )
    return( FALSE );

  XMLFile = XMLFilesColl->Get(EInfo.EditorID);
  if( !XMLFile )
    return( FALSE );

  int LineFound = EInfo.CurLine, x_pos = 0;

  if( FKeyCode == VK_UP ) //  
  {
    bool fnd = FindMethodDefinition(LineFound, x_pos);
    //if( !fnd )
    // fnd = FindMethodImplementation(LineFound, x_pos, EInfo.TotalLines);

    if( !fnd ) //|| EInfo.CurLine == LineFound )
    {
      set_cursor_pos(0, -1, &EInfo);
      int Find = FindInAnotherFile(TRUE);
      return( Find == EEC_OPEN_ERROR ? FALSE : TRUE );
    }
  }
  else //  
  {
    bool fnd = FindMethodImplementation(LineFound, x_pos);

    //if( !fnd )
    // fnd = FindMethodDefinition(LineFound, x_pos, EInfo.TotalLines);

    if( !fnd )
    {
      set_cursor_pos(0, -1, &EInfo);
      int Find = FindInAnotherFile(FALSE);
      return( Find == EEC_OPEN_ERROR ? FALSE : TRUE );
    }
  }

  set_cursor_pos(x_pos, LineFound, &EInfo);
  return( LineFound != -1? TRUE : FALSE );
}//processCtrlShiftUpDown

int CTextNavigate::strreplace(char *str, const char *pattern, const char *value)
{ 
  if( !str || !pattern || !value )
    return( -1 );

  char *s = crt::strstr(str, pattern);
  if( !s )
    return( -1 );

  int n_roundbrackets = 0;
  char *ch = str;
  while( ch != s )
    if( *ch++ == '(' )n_roundbrackets++;
  if( *value == '(' )
    n_roundbrackets++;
  else if( *pattern == '(' )
         n_roundbrackets++;

  int pattern_len = strlen(pattern); int value_len = strlen(value);
  
  if( pattern_len > value_len )
  {
    strncpy(s, value, value_len);
    strcpy(s + value_len, s + pattern_len);
  }
  else if( pattern_len < value_len )
  {
    int s_len = strlen(s);
    memmove(s + value_len, s + pattern_len, s_len - pattern_len + 1);
    strncpy(s, value, value_len);
    s[s_len + value_len - pattern_len+1] = 0;
  }
  else
   strncpy(s, value, value_len);

  return( n_roundbrackets );
}//strreplace

void CTextNavigate::ReplaceSpecRegSymbols(char *str)
{ 
  static char specSymbols[] = "()[]{}|";

  for(UINT i = 0; i < strlen(specSymbols); i++ )
  {
    char sS = specSymbols[i];
    for( int j = strlen(str); j >= 0; j-- )
    {
      char *s = &str[j];
      if( sS != *s )
       continue;
      int s_len = strlen(s);
      memmove(s + 1, s, s_len);
      *s = '\\';
      s[s_len+1] = 0;
    }
  }
}//ReplaceSpecRegSymbols

int CTextNavigate::SearchForMethodImplementation(int &CurLine, int GlobalProc)
{
 #ifdef _DEBUG
  FarSprintf(tmp_str, "==========SearchForMethodImplementation", "");
  WRITE_TO_LOG_FILE(tmp_str);
 #endif

  PLanguage Language = XMLFile->Language;
  
  if( !Language )
    return( FALSE );

  if( GlobalProc )
    Method = Language->Method;
  else
  {
    Class = Language->Class;
    if( !Class )return( FALSE );
    Method = Class->Method;
  }

  if( !Method )
    return( FALSE );

  if( !Method->Name || !Method->Implementation )
   return( FALSE );

  char MethodImplementation[200];
  memset(MethodImplementation, 0, 200);
  strcpy(MethodImplementation, Method->Implementation);
  int MethodTypePos = strreplace(MethodImplementation, s_MethodType, Method->Type);

  int ClassNamePos = -1;
  if( !GlobalProc)
    ClassNamePos = strreplace(MethodImplementation, s_ClassName,  Class->Name);
  MethodNamePos = strreplace(MethodImplementation, s_MethodName, Method->Name);

  SMatches m; char *StringText;
  if( !SearchBackward(MethodImplementation, CurLine, StringText, m) )
    return( FALSE );
    
  GetMatch(MethodType, m, StringText, MethodTypePos);
  if( !GlobalProc )
    GetMatch(ClassName, m, StringText, ClassNamePos);
  GetMatch(MethodName, m, StringText, MethodNamePos);
#ifdef _DEBUG
 FarSprintf(tmp_str, "MethodName=%s", MethodName);
 WRITE_TO_LOG_FILE(tmp_str);
#endif


  if( !GlobalProc )
  {
    strcpy(ClassDefinition, Class->Definition);
    strreplace(ClassDefinition, s_ClassName, ClassName);
  }
  return( TRUE );
}//SearchForMethodImplementation

bool CTextNavigate::SearchForMethodDefinition2(int &CurLine, bool GlobalProc)
{
 #ifdef _DEBUG
  FarSprintf(tmp_str, "==========SearchForMethodDefinition2", "" );
  WRITE_TO_LOG_FILE(tmp_str);
 #endif

  PLanguage Language = XMLFile->Language;

  if( !Language )
    return( FALSE );

  if( GlobalProc )
    Method = Language->Method;
  else
  {
    Class = Language->Class;
    if( !Class )return( FALSE );
    Method = Class->Method;
  }
  
  if( !Method )
    return( FALSE );

  strcpy(MethodDefinition, Method->Definition);

  int MethodTypePos = strreplace(MethodDefinition, s_MethodType, Method->Type);
  MethodNamePos = strreplace(MethodDefinition, s_MethodName, Method->Name);


  if( !MethodDefinition )
    return( FALSE );

  SMatches m; char *StringText;
  if( !SearchBackward(MethodDefinition, CurLine, StringText, m) )
    return( FALSE );

  GetMatch(MethodType, m, StringText, MethodTypePos);
  GetMatch(MethodName, m, StringText, MethodNamePos);

  if( !GlobalProc )
  {
    //  
    strcpy(ClassDefinition, Class->Definition);
    int ClassNamePos = strreplace(ClassDefinition, s_ClassName, Class->Name);

    if( !SearchBackward(ClassDefinition, CurLine, StringText, m) )
      return( FALSE );

    GetMatch(ClassName, m, StringText, ClassNamePos);

    if( !*ClassName || !Method->Implementation )
     return( FALSE );
  }
  
  memset(MethodImplementation, 0, 200);
  strcpy(MethodImplementation, Method->Implementation);
  //  MethodType ClassName.MethodName
  ReplaceSpecRegSymbols(MethodType);

  strreplace(MethodImplementation, s_MethodType, MethodType);
  if( !GlobalProc )
  {
    ReplaceSpecRegSymbols(ClassName);
    strreplace(MethodImplementation, s_ClassName,  ClassName);
  }  
  ReplaceSpecRegSymbols(MethodName);
  MethodNamePos = strreplace(MethodImplementation, s_MethodName, MethodName);
  return( TRUE );
}//SearchForMethodDefinition2

bool CTextNavigate::SearchForMethodImplementation2(int &CurLine, int &x_pos)
{
 #ifdef _DEBUG
  FarSprintf(tmp_str, "=========SearchForMethodImplementation2", "");
  WRITE_TO_LOG_FILE(tmp_str);
 #endif

  SMatches m; char *StringText;
  if( SearchForward(MethodImplementation, CurLine, StringText, m) )
  {
    x_pos = m.s[MethodNamePos];
    return( TRUE );
  }  
  return( FALSE );
}//SearchForMethodImplementation2

bool CTextNavigate::SearchBackward(char *RegExpr, int &CurLine, const char *&StringText, SMatches &m)
{
  if( !reg.SetExpr(RegExpr) )
    return( FALSE );

  struct EditorGetString egs;
  egs.StringNumber = -1;

  struct EditorSetPosition esp;
  esp.CurPos = esp.CurTabPos = esp.TopScreenLine = esp.LeftPos = esp.Overtype = -1;
  esp.CurLine = CurLine;

  while( esp.CurLine >= 0 )
  {
    Info.EditorControl(ECTL_SETPOSITION,&esp);
    Info.EditorControl(ECTL_GETSTRING,&egs);

    if( reg.Parse((char *)egs.StringText, &m) )
    {
      CurLine = esp.CurLine;
      StringText = egs.StringText;
      break;
    }
    esp.CurLine--;
    if( CheckForEsc()) return( FALSE );
  }
  return( esp.CurLine != -1 );
}

bool CTextNavigate::SearchForward(char *RegExpr, int &CurLine, const char *&StringText, SMatches &m)
{
  if( !reg.SetExpr(RegExpr) )
    return( FALSE );

  struct EditorGetString egs;
  egs.StringNumber = -1;

  struct EditorSetPosition esp;
  esp.CurPos = esp.CurTabPos = esp.TopScreenLine = esp.LeftPos = esp.Overtype = -1;

  struct EditorInfo EInfo;
  if( !Info.EditorControl(ECTL_GETINFO, &EInfo) )
    return( FALSE );

  for( esp.CurLine = CurLine; esp.CurLine < EInfo.TotalLines; esp.CurLine++ )
  {
    Info.EditorControl(ECTL_SETPOSITION,&esp);
    Info.EditorControl(ECTL_GETSTRING,&egs);

    if( reg.Parse((char *)egs.StringText, &m) )
    {
      CurLine = esp.CurLine;
      StringText = egs.StringText;
      return( TRUE );
    }
    if( CheckForEsc() ) return( FALSE );
  }
  return( FALSE );
}//SearchForward

bool CTextNavigate::IsInClassDefinition(int CurLine)
{
  PLanguage Language = XMLFile->Language;

  if( !Language )
    return( FALSE );

  Class = Language->Class;
  if( !Class )return( FALSE );

  int Beg = CurLine;
  //  
  strcpy(ClassDefinition, Class->Definition);
  int ClassNamePos = strreplace(ClassDefinition, s_ClassName, Class->Name);

  SMatches m; char *StringText;
  if( !SearchBackward(ClassDefinition, CurLine, StringText, m) )
    return( FALSE );

  int ClassBegin = CurLine;
  GetMatch(ClassName, m, StringText, ClassNamePos);

  if( !ClassName )
    return( FALSE );

  if( !SearchForward(Class->End, CurLine, StringText, m) )
    return( FALSE );

  return( CurLine >= Beg && ClassBegin <= Beg );
}//IsInClassDefinition

bool CTextNavigate::FindMethodImplementation(int &CurLine, int &x_pos)
{
 #ifdef _DEBUG
  FarSprintf(tmp_str, "==========FindMethodImplementation", "");
  WRITE_TO_LOG_FILE(tmp_str);
 #endif
  int Beg = CurLine + 1;
  GlobalProc = !IsInClassDefinition(CurLine);
  if( !SearchForMethodDefinition2(CurLine, GlobalProc) )
    return( FALSE );
  CurLine = Beg;
  return( SearchForMethodImplementation2(CurLine, x_pos) );
}//FindMethodImplementation

bool CTextNavigate::SearchForMethodDefinition(int &CurLine, int &x_pos, bool GlobalProc)
{
#ifdef _DEBUG
 FarSprintf(tmp_str, "ClassDefinition=%s", ClassDefinition);
 WRITE_TO_LOG_FILE(tmp_str);
#endif
  SMatches m; char *StringText;

  if( !GlobalProc )
    if( !SearchBackward(ClassDefinition, CurLine, StringText, m) )
      return( FALSE );

  strcpy(MethodDefinition, Method->Definition);
  ReplaceSpecRegSymbols(MethodType);
  strreplace(MethodDefinition, s_MethodType, MethodType);

  ReplaceSpecRegSymbols(MethodName);
  int Pos = strreplace(MethodDefinition, s_MethodName, MethodName);

  int Res;
  GlobalProc ? CurLine-- : CurLine++;
  if( GlobalProc )
    Res = SearchBackward(MethodDefinition, CurLine, StringText, m);
  else
    Res = SearchForward(MethodDefinition, CurLine, StringText, m);
  if( Res )
  {
    x_pos = m.s[Pos];
    return( TRUE );
  }
  return( FALSE );
}//SearchForMethodDefinition

bool CTextNavigate::IsGlobalMethodImplementation(int CurLine)
{
  int GlobalMethodImplementationPos = -1, ClassMethodImplementationPos = -1;
  int Beg = CurLine;

  if( SearchForMethodImplementation(Beg, FALSE) )
    ClassMethodImplementationPos = Beg;

  if( SearchForMethodImplementation(CurLine, TRUE) )
    GlobalMethodImplementationPos = CurLine;

  if( GlobalMethodImplementationPos == ClassMethodImplementationPos )
    return( FALSE );

  return( GlobalMethodImplementationPos > ClassMethodImplementationPos );
}//IsGlobalMethodImplementation

bool CTextNavigate::FindMethodDefinition(int &CurLine, int &x_pos)
{
 #ifdef _DEBUG
  FarSprintf(tmp_str, "==========FindMethodDefinition", "");
  WRITE_TO_LOG_FILE(tmp_str);
 #endif
  GlobalProc = IsGlobalMethodImplementation(CurLine);
  if( !SearchForMethodImplementation(CurLine, GlobalProc) )
    return( FALSE );

  return( SearchForMethodDefinition(CurLine, x_pos, GlobalProc) );
}//FindMethodDefinition

int CTextNavigate::FindHeaderOrSourceFileName() //(char *FileName)
{
 #ifdef _DEBUG
   WRITE_TO_LOG_FILE("===FindHeaderOrSourceFileName");
 #endif
  PLanguage Language = XMLFile->Language; //s->Get(0);

  if( Language )
  {
    char *Headers = Language->Headers;
    if( Headers )
    {
      struct EditorInfo EInfo;
      Info.EditorControl(ECTL_GETINFO, &EInfo);

      char cur_file_name[ MAX_PATH ];
      memset( cur_file_name, 0, MAX_PATH );
      strncpy(cur_file_name, EInfo.FileName, strlen(EInfo.FileName) );

      HeaderOrSourceFileName = new char[MAX_PATH];
      //memset(HeaderOrSourceFileName, 0, MAX_PATH);
      strcpy(HeaderOrSourceFileName, Headers);
      
      if( FSF.ProcessName(Headers, cur_file_name, PN_CMPNAMELIST|PN_SKIPPATH ) )
      {
        char *SourceFiles = Language->SourceFiles;
        memset(HeaderOrSourceFileName, 0, MAX_PATH);
        strcpy(HeaderOrSourceFileName, SourceFiles);
      }

   #ifdef _DEBUG
    FarSprintf(tmp_str, "cur_file_name=\r\n%s", cur_file_name);
    WRITE_TO_LOG_FILE(tmp_str);
   #endif

   #ifdef _DEBUG
    FarSprintf(tmp_str, "HeaderOrSourceFileName=\r\n%s", HeaderOrSourceFileName);
    WRITE_TO_LOG_FILE(tmp_str);
   #endif

      if( FSF.ProcessName(cur_file_name, HeaderOrSourceFileName, PN_GENERATENAME) )
         return( FSF.LStricmp(EInfo.FileName, HeaderOrSourceFileName) );
    }//if
  }
  return( FALSE );
}//FindHeaderOrSourceFileName

int CTextNavigate::FindInAnotherFile(bool Header)
{
 #ifdef _DEBUG
  FarSprintf(tmp_str, "=============FindInAnotherFile", "");
  WRITE_TO_LOG_FILE(tmp_str);
 #endif

  IsHeader = Header;
  int res = OpenHeaderOrSource();
#ifdef _DEBUG
 FarSprintf(tmp_str, "FindInAnotherFile::res=%d", res);
 WRITE_TO_LOG_FILE(tmp_str);
#endif

  return( res );
}//FindInAnotherFile

int CTextNavigate::OpenHeaderOrSource(void)
{
 #ifdef _DEBUG
   WRITE_TO_LOG_FILE("===========OpenHeaderOrSource");
 #endif
  if( FindHeaderOrSourceFileName() ) //HeaderOrSourceFileName) )
  {
  #ifdef _DEBUG
   FarSprintf(tmp_str, "HeaderOrSourceFileName=%s", HeaderOrSourceFileName);
   WRITE_TO_LOG_FILE(tmp_str);
  #endif

    int res = Info.Editor(HeaderOrSourceFileName,
                     NULL,
                     0,0,-1,-1,
                     EF_CREATENEW, //EF_NONMODAL|EF_ENABLE_F6, //
                     0, 1); // == EEC_OPEN_ERROR? FALSE : TRUE );
    return ( res );
  }
  return( 0 ); //FALSE
}//OpenHeaderOrSource

int CTextNavigate::ShowPluginMenu()
{
  static const int MItemsSimple[] = { MFindNext, MFindPrev, MOpenFile, MConfig, MConfig};
  static const int MItemsLang[] = { MFindNext, MFindPrev, MOpenFile, MFindPrototype, MFindMethod, MOpenSourceHeader, MConfig, MConfig};

  int IsSimpleMenu = XMLFile->Language == NULL;
  const int *Msgs = IsSimpleMenu ? MItemsSimple : MItemsLang;
  int n_Items = IsSimpleMenu ? 5 : 8;

  PFFarMenuItem fmi = new FFarMenuItem[n_Items];
  for( int i = 0; i < n_Items; i++ )
  {
    if( i == n_Items - 2)
      fmi[i].Separator = TRUE;
    else
      fmi[i].Text = (char *)get_msg(Msgs[i]);
  }
  PPluginMenu PluginMenu = new CPluginMenu(n_Items, fmi);
  delete fmi;
  
  int i;
  do
  {
    i = PluginMenu->Execute(get_msg(STitle), NULL);

    switch( i )
    {
      case 0: //MFindNext
              TextNavigate->processCtrlAltUpDown(VK_DOWN, 0);
              break;
      case 1: //MFindPrev
              TextNavigate->processCtrlAltUpDown(VK_UP, 0);
              break;
      case 2: //MOpenFile
              TextNavigate->processCtrlEnter();
              break;
      case 3: //MFindPrototype
              TextNavigate->processCtrlShiftUpDown(VK_UP);
              break;
      case 4: //MFindMethod || SCfgTitle
              if( IsSimpleMenu )
                config_plugin();
              else
                TextNavigate->processCtrlShiftUpDown(VK_DOWN);
              break;
      case 5: //MOpenSourceHeader
              TextNavigate->OpenHeaderOrSource();
              break;
      case 7: //SCfgTitle
              config_plugin();
              break;
    }
  }while( (IsSimpleMenu && (i == 4)) || (i == 7) );
  
  delete PluginMenu;
  return( TRUE );
}//ShowPluginMenu

void CTextNavigate::config_plugin()
{
  int height = 67, weight = 13;

  FDialogItem itm[] =
  {
   //FDI_CONTROL(DI_DOUBLEBOX,3,1,63,11,0,get_msg(SCfgTitle)),
   FDI_DOUBLEBOX(height,weight,get_msg(SCfgTitle)),

   FDI_CHECK(4,2,get_msg(SActive)),
   FDI_CHECK(4,3,get_msg(SAddDigits)),
   FDI_CHECK(4,4,get_msg(SCaseSensitive)),
   FDI_CHECK(4,5,get_msg(SCyclicSearch)),
   FDI_CHECK(4,6,get_msg(SSearchSelection)),
   FDI_LABEL(4,7,get_msg(SAddSymbols)),
   FDI_EDIT(4,8,62),
   FDI_SEPARATOR(9),

   FDI_DEFBUTTON(12,10,get_msg(SSave)),
   FDI_BUTTON(42,10,get_msg(SCancel))
  };

  static const int n_itm = sizeof(itm)/sizeof(*itm);
  PConfigDialog dlg = new CConfigDialog(n_itm, itm);

  dlg->Item(1)->Selected = active;
  dlg->Item(2)->Selected = adddigits;
  dlg->Item(3)->Selected = casesensitive;
  dlg->Item(4)->Selected = cyclicsearch;
  dlg->Item(5)->Selected = searchselection;
  strcpy(dlg->Item(7)->Data, s_AdditionalLetters);
  dlg->Item(7)->Focus = TRUE;
  //...
  dlg->Item(n_itm-2)->Flags = DIF_CENTERGROUP;
  dlg->Item(n_itm-1)->Flags = DIF_CENTERGROUP;
  
  int d_code = dlg->Execute(height, weight);
  if( d_code == n_itm - 2 )
  {
    SetRegKey(HROOT, "", reg_key.active, (active=dlg->Item(1)->Selected));
    SetRegKey(HROOT, "", reg_key.adddigits, (adddigits=dlg->Item(2)->Selected));
    SetRegKey(HROOT, "", reg_key.casesensitive, (casesensitive=dlg->Item(3)->Selected));
    SetRegKey(HROOT, "", reg_key.cyclicsearch, (cyclicsearch=dlg->Item(4)->Selected));
    SetRegKey(HROOT, "", reg_key.searchselection, (searchselection=dlg->Item(5)->Selected));
    strcpy(s_AdditionalLetters, dlg->Item(7)->Data);
    SetRegKey(HROOT, "", reg_key.AdditionalLetters, s_AdditionalLetters);
  }
  delete dlg;
  InitUnion();
}//config_plugin

int CTextNavigate::GetMatch(char *Match, const SMatches &m, const char *str, int n)
{
  if( n == -1 )return( -1 );
  size_t Len = (size_t)(m.e[n]-m.s[n]);
  if ( Len )
  {
    strncpy(Match, str+m.s[n], Len);
    Match[Len] = 0;
  }
  return( Len );
}//GetMatch

//CSearchPaths
CSearchPaths::CSearchPaths(PSgmlEl elem)
{
  //memset(this, 0, sizeof(CSearchPaths));
  AddSearchPaths(elem);
  pathways = new pw_array[1];
  was_found = new wf_array[1];
  (*pathways)[0] = (char *)get_def_path();
  pw_count = 1;
}

CSearchPaths::~CSearchPaths()
{
  for(int i = 0; i < EnvVarsCount; i++)
  {
    delete env_vars[EnvVarsCount].EnvVar;
    delete env_vars[EnvVarsCount].EnvVarValue;
  }
  free_find_data();
  free_pathways();
  if( s_PathWays )crt::free(s_PathWays);
  delete was_found;
  delete pathways;
}

//static UCHAR spec_file_symbols[] = "\\/.$_!@#?*-";
static const SCharData SFileNamesData = { { 0x0, 0x83FFE41A, 0x97FFFFFF, 0x7FFFFFE, 0,0,0,0 } };

bool CSearchPaths::ProcessCtrlEnter(PLanguage Language)
{
/*
  memset( &CharSet, 0, 32 );
  AddEngCharsToUnion();
  AddDigitsToUnion();
  AddSubSetToUnion(spec_file_symbols);
*/
  memcpy(&CharSet, &SFileNamesData, 32);
  if( !get_filename() )
     return( FALSE );

  int pos = find_file(Language ? Language->ExcludedFileExts : NULL);
  if( !pos )
    return( FALSE );

  if( --pos )
    pos = ShowSelectFileMenu();
  if( pos == -1 )
    return( FALSE );
    
  char open_file_name[ MAX_PATH ];
  if( !get_full_file_name(open_file_name, pos) )
  {
    ClearAfterSearch();
    return( FALSE );
  }
  if( !file_exists(open_file_name) )
    return( FALSE );

  int res = Info.Editor(open_file_name,
                 NULL,
                 0,0,-1,-1,
                 0, //EF_NONMODAL|EF_ENABLE_F6,
                 0, 1);
  if( res == EEC_OPEN_ERROR )
  {
    return( FALSE ); //      
  }//if

  return( TRUE );
}//ProcessCtrlEnter

void CSearchPaths::AddSearchPaths(PSgmlEl elem)
{
#ifdef _DEBUG
 FarSprintf(tmp_str, "CSearchPaths::CSearchPaths::", "");
 WRITE_TO_LOG_FILE(tmp_str);
#endif

  PSgmlEl SearchPaths = GetChild(elem, s_SearchPaths);

  if( SearchPaths && SearchPaths->GetChrParam(s_Value) )
  {
    char tmpPathWays[ PWL ];
    FSF.ExpandEnvironmentStr(SearchPaths->GetChrParam(s_Value), tmpPathWays, PWL);

    if( s_PathWays )
    {
      char *tmp_PathWays = (char *)crt::malloc(strlen(s_PathWays) + strlen(tmpPathWays)+3);
      strcat(strcat(strcpy(tmp_PathWays, s_PathWays), tmpPathWays), ";");
      crt::free(s_PathWays);
      s_PathWays = tmp_PathWays;
    }
    else
    {
      s_PathWays = (char *)crt::malloc(strlen(tmpPathWays)+3);
      strcat(strcpy(s_PathWays, tmpPathWays), ";");
    }
    s_PathWays_len = strlen(s_PathWays);
  }

  PSgmlEl SpecVars = GetChild(elem, s_SpecVars);

  if( SpecVars )
  {
    PSgmlEl Var = GetChild(SpecVars, s_Var);

    while( Var && (EnvVarsCount < MAX_ENV_VARS) )
    {
      if( Var->getname() && !strcmp(Var->getname(), s_Var) )
      {
        InitParam(env_vars[EnvVarsCount].EnvVar, Var->GetChrParam(s_Name));
        InitParam(env_vars[EnvVarsCount].EnvVarValue, Var->GetChrParam(s_Value));
        EnvVarsCount++;
      }
      Var = Var->next();
    }
  }
}//AddSearchPaths

void CSearchPaths::MakePathWays()
{
  if( s_PathWays )
  {
    char *c, *p = s_PathWays;
    while( (c = crt::strchr(p, ';')) != NULL && pw_count < PWC)
    {
      (*pathways)[pw_count] = p;
      *c = 0;
      p = c+1;
      pw_count++;
    }//while
    (*pathways)[pw_count] = p;
  }

  ResolveEnvVars();
}//MakePathWays

void CSearchPaths::PrepareForSearch()
{
  free_find_data();
  file_name = new char[MAX_PATH];
  last_path = new char[MAX_PATH];
}//PrepareForSearch

void CSearchPaths::ClearAfterSearch()
{
  //free_pathways();
  free_find_data();
  delete last_path;
  delete file_name;
}//ClearAfterSearch

void CSearchPaths::free_find_data(void)
{
  if( wf_count )
  for( register UINT i = 0; i < wf_count; i++ )
  {
    if( (*was_found)[i].file_name )
      crt::free((void *)(*was_found)[i].file_name);
    if( (*was_found)[i].file_path )
      crt::free((void *)(*was_found)[i].file_path);
  }//for
  wf_count = 0;
}//free_find_data

int CSearchPaths::get_filename(void)
{
  PrepareForSearch();

  struct EditorGetString EStr; // editor  string
  EStr.StringNumber = -1; // current string
  if( Info.EditorControl(ECTL_GETSTRING, &EStr) )
  {
    int mx, my;
    if( get_cursor_pos(mx, my) )
    {
      int begin_word_pos;

      if( get_word(file_name, EStr.StringText, mx, EStr.StringLength, begin_word_pos) )
      {
        char *beg, *end;
        int len = strlen(file_name);

        for( int i = 0; i < len; i++ )
          if( file_name[i]=='/' )
            file_name[i]='\\';

        beg = file_name;
        while( (end = crt::strchr(beg, '\\')) != NULL )
          beg = end + 1;

        //-        -
        if( beg == file_name )
        {
          find_file_name = file_name;

          find_file_path = NULL;
          return( TRUE );
        }

        if( (beg-file_name == 1) && (file_name[0] == '\\') )
        {
          find_file_name = beg;
          find_file_path = (char *)path_root;
          return( TRUE );
        }//if

        *(beg-1) = 0;
        find_file_name = beg;
        find_file_path = file_name;

        return( TRUE );
      }
    }
  }
  ClearAfterSearch();
  return( FALSE );
}//get_filename

int CSearchPaths::find_file(char *ExcludedFileExts)
{
  MakePathWays();
  GetCurrentDirectory(MAX_PATH-1, last_path);

  HANDLE HF;
  WIN32_FIND_DATA FD;
  //FAR_FIND_DATA FD;

  for( int m2 = 0; m2 < 2; m2++ )
  {
    //     .  - any ext.
    for( unsigned int i = 0; i < pw_count; i++ )
    {
      if( !SetCurrentDirectory((*pathways)[i]) )
        continue;
/*#ifdef _DEBUG
 FarSprintf(tmp_str, "pathways[%d]=%s", i, pathways[i]);
 WRITE_TO_LOG_FILE(tmp_str);
#endif*/
      if( find_file_path )
        if( !SetCurrentDirectory(find_file_path) )
          continue;

      if( (HF = FindFirstFile(find_file_name, &FD)) == INVALID_HANDLE_VALUE )
        continue;

      unsigned int len;
      do
      {
        if( FD.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
         continue;

        if( AlreadyFound((*pathways)[i], FD.cFileName) )
         continue;

        if( ExcludedFileExts && FSF.ProcessName(ExcludedFileExts, FD.cFileName, PN_CMPNAMELIST|PN_SKIPPATH) )
         continue;

        len = strlen(FD.cFileName);
        (*was_found)[wf_count].file_name = (char *)crt::malloc(len+1);
        strcpy((char*)(*was_found)[wf_count].file_name, FD.cFileName);
        (*was_found)[wf_count].file_path = NULL;
        (*was_found)[wf_count].path_index = i;
        //(*was_found)[wf_count].FileSize = FD.nFileSizeLow;
        wf_count++;
      }while( FindNextFile(HF, &FD) && wf_count < WFC );
      FindClose(HF);
    }//for

    if( !wf_count ) strcat(find_file_name, ".*");
    else break;
  }//for

  SetCurrentDirectory(last_path);
  if( !wf_count )
    ClearAfterSearch();
  return( wf_count );
}//find_file

int CSearchPaths::ShowSelectFileMenu()
{
  PFFarMenuItem fmi = new FFarMenuItem[wf_count];
  for( UINT i = 0; i < wf_count; i++ )
  {
    char tmp_str[MAX_PATH];
    FarSprintf(tmp_str, "%-12s in %s", (*was_found)[i].file_name, (*pathways)[(*was_found)[i].path_index]);
    fmi[i].Text = new char[MAX_PATH];
    if( i < 9 )
      FarSprintf(fmi[i].Text, "\&%d %s", i + 1, tmp_str);
    else if( i < 15 )
      FarSprintf(fmi[i].Text, "\&%c %s", i - 9 + 'A', tmp_str);
    else
      FarSprintf(fmi[i].Text, "%-2s%s", "", tmp_str);
  }
  PPluginMenu PluginMenu = new CPluginMenu(wf_count, fmi);

  char msgSelect[256], msgTotal[256];
  const char *PMStrings[] =
  {
    get_msg(MSelect),
    get_msg(MTotal)
  };

  FarSprintf(msgSelect, PMStrings[0], find_file_name);
  FarSprintf(msgTotal, PMStrings[1], wf_count);

  int menu_code = PluginMenu->Execute(msgSelect, msgTotal);

  delete PluginMenu;
  for( UINT i = 0; i < wf_count; i++ )
    delete fmi[i].Text;
  delete fmi;

  if( menu_code == -1 )
    ClearAfterSearch();
  return( menu_code );
}//ShowSelectFileMenu

int CSearchPaths::get_full_file_name(char *dest, int pos)
{
  return( get_full_file_name(dest, &(*was_found)[pos]) );
}//get_full_file_name

int CSearchPaths::get_full_file_name(char *dest, LPFND fnd)
{
  if( fnd->file_path )
    strcpy(dest, fnd->file_path);
  else
    strcpy(dest, (*pathways)[fnd->path_index]);

  if( find_file_path )
  {
    if( dest[strlen(dest)-1]!='\\' )
      strcat(dest, "\\");
    strcat(dest, find_file_path);
  }//if

  if( dest[strlen(dest)-1]!='\\' )
   strcat(dest, "\\");

  strcat(dest, fnd->file_name);

  return( strlen(dest) );
}//get_full_file_name

int CSearchPaths::AlreadyFound(char *path, char *file_name)
{
  _FND fnd;
  fnd.file_name = file_name;
  fnd.file_path = path;
  char cur_file_name[ MAX_PATH ]; int cur_file_name_len;

  if( (cur_file_name_len = get_full_file_name(cur_file_name, &fnd)) == 0 )
    return( FALSE );
  
  for( UINT i = 0; i < wf_count; i++ )
  {
    char file_name[ MAX_PATH ]; int file_name_len;
    if( (file_name_len = get_full_file_name(file_name, &(*was_found)[i])) == 0 )
      return( FALSE );

    if( (file_name_len == cur_file_name_len) &&
         !FSF.LStrnicmp(file_name, cur_file_name, file_name_len) )
     return( TRUE );
  }
  return( FALSE );
}//AlreadyFound

void CSearchPaths::ResolveEnvVars(void)
{
 #ifdef _DEBUG
  FarSprintf(tmp_str, "=====ResolveEnvVars::pw_count=%d;EnvVarsCount=%d", pw_count,EnvVarsCount);
  WRITE_TO_LOG_FILE(tmp_str);
 #endif

  for( UINT i = 0; i < pw_count; i++ )
  {
    char *pw = (*pathways)[i];
    if( !pw ) continue;
    
    if( (*pw == '$') && (pw[1] == '(') ) //  
    {
      for( int j = EnvVarsCount - 1; j >= 0; j-- )
      {
        int EnvVarLen = strlen(env_vars[j].EnvVar);

        if( !FSF.LStrnicmp(&pw[2], env_vars[j].EnvVar, EnvVarLen)  &&
             pw[EnvVarLen + 2] == ')' )
        {
          // $(ENVVAR)  EnvVarValue
          int EnvVarValueLen = strlen(env_vars[j].EnvVarValue);
          int pw_len = strlen(&pw[EnvVarLen + 3]);
          char *pathway = new char[EnvVarValueLen + pw_len + 1];
          strcpy(pathway,env_vars[j].EnvVarValue);
          strcat(pathway, &pw[EnvVarLen + 3]);
          //    ,    
          if( (*pathways)[i] < s_PathWays || (*pathways)[i] > s_PathWays + s_PathWays_len )
            delete (*pathways)[i]; //crt::free(pathways[i]);
          pw = (*pathways)[i] = pathway;
        }
      }//for
    }//if
    char *spw = crt::strstr(pw, "\\...");
    if( spw ) //  
    {
      *spw = 0;
      FindAllSubDirs(pw);
    }
  }//for
}//ResolveEnvVars

void CSearchPaths::FindAllSubDirs(char *RootDir)
{
  HANDLE HF;
  WIN32_FIND_DATA FD;
  if( SetCurrentDirectory(RootDir) )
  {
    if( (HF = FindFirstFile("*.*", &FD)) == INVALID_HANDLE_VALUE )
      return;
    do
    {
      if( (FD.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) &&
          FD.cFileName[0] != '.' )
      {
        char *pathway = new char[strlen(RootDir) + strlen(FD.cFileName) + 3];
        strcat(strcat(strcpy(pathway, RootDir), "\\"), FD.cFileName);
        (*pathways)[pw_count++] = pathway;
        FindAllSubDirs(pathway);
      }
    }while( FindNextFile(HF, &FD) && pw_count < PWC );
    FindClose(HF);
  }
  SetCurrentDirectory(RootDir);
}//FindAllSubDirs

char *CSearchPaths::get_def_path(void)
{
  char *def_path = new char[MAX_PATH];
  
  struct EditorInfo EInfo;
  Info.EditorControl(ECTL_GETINFO, &EInfo);
  
  char *c, *p = (char *)EInfo.FileName;
  while( (c=crt::strchr(p, '\\'))!=NULL)
    p = c + 1;
   
  if( p == EInfo.FileName )
  {
    if( GetCurrentDirectory(MAX_PATH-1, def_path) == 0 )
    {
      delete def_path;
      return( NULL );
    }
    return( def_path );
  }//if
  strncpy(def_path, EInfo.FileName, p-1-EInfo.FileName);
  return( def_path );
}//get_def_path

void CSearchPaths::free_pathways(void)
{
  for( UINT i = 0; i < pw_count; i++ )
  {
    if( (*pathways)[i] >= s_PathWays && (*pathways)[i] <= s_PathWays + s_PathWays_len )
      continue;
    delete (*pathways)[i];
  }
}//free_pathways

//s_Language
SLanguage::SLanguage(PXMLFile owner, PSgmlEl elem)
{
#ifdef _DEBUG
 FarSprintf(tmp_str, "s_Language::s_Language::1:elem=%s", elem->getname());
 WRITE_TO_LOG_FILE(tmp_str);
#endif
  Owner = owner;
  if( elem->getname() && !strcmp(elem->getname(), s_Language) )
  {
    InitParam(name, elem->GetChrParam(s_Name));
    InitParam(FileExts, elem->GetChrParam(s_FileExts));
    InitParam(ExcludedFileExts, elem->GetChrParam(s_ExcludedFileExts));
    InitParam(SourceFiles, elem->GetChrParam(s_SourceFiles));
    InitParam(Headers, elem->GetChrParam(s_Headers));
    //InitParam(Desc, elem->GetChrParam(s_Name));

    if( GetChild(elem, s_Class) )
      Class = new SClass(elem);

    if( GetChild(elem, s_GlobalProc) )
      Method = new SMethod(elem, s_GlobalProc);
  }

  if( GetChild(elem, s_SearchPaths) )
    Owner->AddSearchPaths(elem);

}

SLanguage::~SLanguage()
{
  if( Method )delete Method;
  if( Class )delete Class;

  delete Headers;
  delete SourceFiles;
  delete ExcludedFileExts;
  delete FileExts;
  delete name;
  //crt::free(Desc);
}

SClass::SClass(PSgmlEl elem)
{
  PSgmlEl Class = GetChild(elem, s_Class);
  if( Class )
  {
    InitParam(Name, Class->GetChrParam(s_Name));
    InitParam(Definition, Class->GetChrParam(s_Definition));
    InitParam(End, Class->GetChrParam(s_End));

    if( GetChild(Class, s_Method) )
     Method = new SMethod(Class, s_Method);
  }
}

SClass::~SClass()
{
  if( Method )
    delete Method;

  delete End;
  delete Definition;
  delete Name;
}

SMethod::SMethod(PSgmlEl elem, char *Tag)
{
  PSgmlEl Method = GetChild(elem, Tag);
  if( Method )
  {
    InitParam(Name, Method->GetChrParam(s_Name));
    InitParam(Type, Method->GetChrParam(s_Type));
    InitParam(Definition, Method->GetChrParam(s_Definition));
    InitParam(Implementation, Method->GetChrParam(s_Implementation));
  }
}

SMethod::~SMethod()
{
  delete Implementation;
  delete Definition;
  delete Type;
  delete Name;
}

//CPluginMenu::CPluginMenu( int NumElemens )
//  : RefArray<FarMenuItem>( NumElemens )
//{}

CPluginMenu::CPluginMenu( int NumElements, PFFarMenuItem Elements, int FNumElements )
  : RefArray<FarMenuItem>( NumElements )
{
  Setup( 0, Elements,(FNumElements == -1) ? NumElements : FNumElements );
}

void CPluginMenu::Setup( int From, PFFarMenuItem p, int ECount )
{
  for ( int n = 0; n < ECount; n++ )
    Setup( From+n,p[n] );
}

FarMenuItem *CPluginMenu::Setup( int num, const FFarMenuItem &mi )
{
  FarMenuItem *p = Item(num);
  if ( !p ) return NULL;

  strcpy(p->Text, mi.Text ? mi.Text : "");
  p->Selected = mi.Selected;
  p->Checked = mi.Checked;
  p->Separator = mi.Separator;

  return p;
}

int CPluginMenu::Execute(const char *Title, const char *Bottom)
{
  return Info.Menu( Info.ModuleNumber,-1,-1,0,FMENU_AUTOHIGHLIGHT|FMENU_WRAPMODE, Title, 
               Bottom, //bottom
               "Contents", //helptopic
               NULL,NULL, //breakkeys, breakcode
               (FarMenuItem *)Items(), Count() );
}

CXMLFile::CXMLFile()
{
  //memset(this, 0, sizeof(CXMLFile));

 #ifdef _DEBUG
  WRITE_TO_LOG_FILE("CXMLFile::CXMLFile");
 #endif
  init(NULL);
}

CXMLFile::CXMLFile(char *xml_file_name)
{
  init(xml_file_name);
}

CXMLFile::~CXMLFile()
{
 #ifdef _DEBUG
  WRITE_TO_LOG_FILE("CXMLFile::~CXMLFile");
 #endif
  delete filepath;
  delete XMLFileName;
  //delete Languages;
  delete SearchPaths;
}

void CXMLFile::init(char *file_name)
{
  //Languages = new CLangColl(NULL);

  if( file_name )
  {
    int len = strlen(file_name) + 1;
    XMLFileName = new char[len]; // (char *)crt::malloc(len);
    strcpy(XMLFileName, file_name);
  }
  else
  {
    XMLFileName = new char[strlen(Info.ModuleName) + 1];
    strcpy(XMLFileName, Info.ModuleName);
  }

  filepath = new char[MAX_PATH];
  int i = strlen(XMLFileName) - 1;
  while( XMLFileName[i] != '.' )
   i--;
  strcpy(filepath, XMLFileName);
  strcpy(XMLFileName + i, ".xml\0");
  while( filepath[i] != '\\' )
   i--;
  filepath[i+1] = 0;
  
  SearchPaths = new CSearchPaths(NULL);
  char *xml_data; UINT sz;
  GetFile(XMLFileName, xml_data, sz);
  loaddata(xml_data, sz);
}

void CXMLFile::AddSearchPaths(PSgmlEl elem)
{
  if( !SearchPaths )
    SearchPaths = new CSearchPaths(NULL);
  SearchPaths->AddSearchPaths(elem);
}

bool CXMLFile::loaddata(const char *data, int len)
{
 #ifdef _DEBUG
  FarSprintf(tmp_str, "============loaddata", "");
  WRITE_TO_LOG_FILE(tmp_str);
 #endif

  if( !(data && len) )
    return( FALSE );

  PSgmlEl base = new CSgmlEl();
  if( !base )
    return( FALSE);

  if( !base->parse(data, len) )
  {
    delete base;
    return( FALSE );
  }
  delete data;
  PSgmlEl basetag = searchbasetag(base);
#ifdef _DEBUG
 FarSprintf(tmp_str, "basetag=%x", basetag );
 WRITE_TO_LOG_FILE(tmp_str);
#endif

  if( basetag && !FSF.LStrnicmp(basetag->GetChrParam(s_version), s_versionID, strlen(s_versionID)) &&
     basetag->child() )
  {
    readcdata(basetag);
    delete base;
    return( TRUE );
  }
  delete base;
  return( FALSE );
}//loaddata

void CXMLFile::readcdata(PSgmlEl basetag)
{
  char *param;

  PSgmlEl elem = basetag->child();
  if( !elem )return;
 #ifdef _DEBUG
  FarSprintf(tmp_str, "\r\n==========readcdata\r\nnelem=%s", elem->GetChrParam("name") );
  WRITE_TO_LOG_FILE(tmp_str);
 #endif

  for( ; elem; elem = elem->next() )
  {
    if( !elem->getname() ) continue;
    if( !strcmp(elem->getname(), s_Include) )
    {
      if( ((param = elem->GetChrParam(s_File)) == NULL) || !filepath )
       continue;
      includefile(param);
    }
    else if( !strcmp(elem->getname(), s_Language) )
    {
      struct EditorInfo EInfo;
      if( !Info.EditorControl(ECTL_GETINFO, &EInfo) )
       continue;

      char *FileExts = elem->GetChrParam(s_FileExts);

      if( FileExts && !FSF.ProcessName(FileExts, (char *)EInfo.FileName, PN_CMPNAMELIST|PN_SKIPPATH) )
       continue;

   #ifdef _DEBUG
    FarSprintf(tmp_str, "readdata::EInfo.FileName=\r\n%s\r\n", EInfo.FileName);
    WRITE_TO_LOG_FILE(tmp_str);
   #endif

      Language = new SLanguage(this, elem);
    }

    else if( !strcmp(elem->getname(), s_SearchPaths) )
    {
      SearchPaths->AddSearchPaths(basetag);
    }

  }
}//readcdata

bool CXMLFile::includefile(char *param)
{
 #ifdef _DEBUG
  FarSprintf(tmp_str, "===includefile", "");
  WRITE_TO_LOG_FILE(tmp_str);
 #endif

  char path[ MAX_PATH ];
  strcpy(path, filepath);
  int i;
  for( i = strlen(path); i; i--)
    if (path[i]=='\\' || path[i]=='/') break;
  strcpy(path+i+1, param);

  char *data; UINT sz;
  GetFile(path, data, sz);
  if( !(data && sz) )
    return( FALSE );

  PSgmlEl BaseEl = new CSgmlEl;

  if( BaseEl->parse(data, sz) )
  {
    PSgmlEl tmpEl = searchbasetag(BaseEl);
    if( tmpEl && !FSF.LStrnicmp(tmpEl->GetChrParam(s_version), s_versionID, strlen(s_versionID)) &&
        tmpEl->child() )
    {
      readcdata(tmpEl);
      delete data;
      delete BaseEl;
      return( TRUE );
    }  
  }
  delete data;
  delete BaseEl;
  return( FALSE);
}//includefile

PSgmlEl CXMLFile::searchbasetag(PSgmlEl elem)
{
  while( elem )
  {
    if ( elem->gettype() == EBLOCKEDEL &&
         elem->getname() && !strcmp(elem->getname(),s_TextNavigate) )
     return(elem);
    elem = elem->next();
  }
  return NULL;
}//searchbasetag
